#include <windows.h>
#include <stdio.h>

#include "resource.h"

/*  Declare Windows procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

/*  Make the class name into a global variable  */
char szClassName [] = "WindowsApp";

//   
bool fullScr (int fsWidth, int fsHeight)
{
 DEVMODE dmScreenSettings;
 memset (&dmScreenSettings, 0, sizeof (dmScreenSettings));
 dmScreenSettings.dmSize=sizeof (dmScreenSettings);
 dmScreenSettings.dmPelsWidth=fsWidth;
 dmScreenSettings.dmPelsHeight=fsHeight;
 dmScreenSettings.dmFields=DM_PELSWIDTH | DM_PELSHEIGHT;

 if (ChangeDisplaySettings (&dmScreenSettings, CDS_FULLSCREEN)!= DISP_CHANGE_SUCCESSFUL)
  return false;
 else
  return true;
}

//  -    
bool isScr (int x, int y)
{
 DEVMODE devMode;//  
 memset (&devMode, 0, sizeof (devMode));//    
 devMode.dmSize=sizeof (devMode);//   Devmode

 for (int i=0; EnumDisplaySettings (0, i, &devMode); i++)
 {
   if (devMode.dmPelsWidth==x && devMode.dmPelsHeight==y)
    return true;
 }

 return false;
}



int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)

{
 HWND hwnd;               /* This is the handle for our window */
 MSG messages;            /* Here messages to the application are saved */
 WNDCLASSEX wincl;        /* Data structure for the windowclass */

 /* The Window structure */
 wincl.hInstance = hThisInstance;
 wincl.lpszClassName = szClassName;
 wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
 wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
 wincl.cbSize = sizeof (WNDCLASSEX);

 /* Use default icon and mouse-pointer */
 wincl.hIcon = LoadIcon (hThisInstance, MAKEINTRESOURCE (ID_PIC));
 wincl.hIconSm = LoadIcon (hThisInstance, MAKEINTRESOURCE (ID_PIC));
 wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
 wincl.lpszMenuName = NULL;                 /* No menu */
 wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
 wincl.cbWndExtra = 0;                      /* structure or the window instance */
 /* Use Windows's default color as the background of the window */
 wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

 /* Register the window class, and if it fails quit the program */
 if (!RegisterClassEx (&wincl))
  return 0;

 //   
 #define mx 256
 char arg1 [mx], arg2 [mx], arg3 [mx], arg4 [mx];
 char mess [256], err [32]={""};
 int i, i2, l=strlen (lpszArgument), x=0, y=0;

 memset (arg1, 0, mx);
 memset (arg2, 0, mx);
 memset (arg3, 0, mx);
 memset (arg4, 0, mx);
 for (i=0; i<l; i++)
 {
  if (lpszArgument [i]==' ')
  {
   for (i2=0; i2<i; i2++)
    arg1 [i2]=lpszArgument [i2];

   for (i2=i+1; i2<l; i2++)
    arg2 [i2-i-1]=lpszArgument [i2];
  }
 }

 l=strlen (arg2);
 for (i=0; i<l; i++)
 {
  if (arg2 [i]=='x')
  {
   for (i2=0; i2<i; i2++)
    arg3 [i2]=arg2 [i2];

   for (i2=i+1; i2<l; i2++)
    arg4 [i2-i-1]=arg2 [i2];

   x=atoi (arg3);
   y=atoi (arg4);
  }
 }

 if (x==0 || y==0)//    
 {
  char mess_ar [5] [64]={"  ,  :",
                         "   . :",
                         "st.exe program.exe 800x600"
                        };
  sprintf (mess, "%s\n%s\n\n%s", mess_ar [0], mess_ar [1], mess_ar [2]);
  MessageBox (NULL, mess, err, MB_OK);
  PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
 }
 else
 {
  //   
  FILE *file;
  file=fopen (arg1, "rb");
  if (file==NULL)
  {
   sprintf (mess, " \"%s\"  .", arg1);
   MessageBox (NULL, mess, err, MB_OK);
   PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
  }
  else
  {
   fclose (file);

   //     
   if (!isScr (x, y))
   {
    sprintf (mess, " %dx%d  .", x, y);
    MessageBox (NULL, mess, err, MB_OK);
    PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
   }
   else
   {
    //   
    fullScr (x, y);

    //     :
    //     ,
    //        
    system (arg1);

    //  -   
    PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
   }
  }
 }

 /* Run the message loop. It will run until GetMessage() returns 0 */
 while (GetMessage (&messages, NULL, 0, 0))
 {
  /* Translate virtual-key messages into character messages */
  TranslateMessage(&messages);
  /* Send message to WindowProcedure */
  DispatchMessage(&messages);
 }

 /* The program return-value is 0 - The value that PostQuitMessage() gave */
 return messages.wParam;
}


/*  This function is called by the Windows function DispatchMessage()  */
LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
 switch (message)             /* handle the messages */
 {
  default:                    /* for messages that we don't deal with */
   return DefWindowProc (NULL, message, wParam, lParam);
 }

 return 0;
}
